<?php
!defined('IN_TIPASK') && exit('Access Denied');

class jiekoucontrol extends base {
	private $jkconfig = array(); //接口配置

	//构造方法
    function jiekoucontrol(& $get, & $post) {
        $this->base(& $get, & $post);
        $this->load('category');
        $this->load('question');
        $this->load('answer');
        $this->load('user');
        $this->load('tag');
        $this->load('jiekou');
    }

	//使用ajax作为名字的原因是ajax不用登陆后台
    function onajax() {
    	if(get_magic_quotes_gpc()) {
	    	$this->jkconfig = json_decode(stripcslashes($this->post['jkconfig']), 1);
    	} else {
    		$this->jkconfig = json_decode($this->post['jkconfig'], 1);
    	}
    	unset($this->post['jkconfig']);

		//获取分类下拉菜单
		if(!empty($this->post['getlist'])) $this->get_class_tree();

		//检测回答问题数组的长度是否匹配
		$count = array();
		$count[] = explode($this->jkconfig['sep'], $this->post['answer_user']);
		$count[] = explode($this->jkconfig['sep'], $this->post['answer_content']);
		$count[] = explode($this->jkconfig['sep'], $this->post['answer_time']);
		if(count(array_unique($count)) != 1) $this->jk_error('回答用户, 回答时间, 回答内容 个数不相同!');

		//创建分类 传递cid过来无需自动创建分类
    	if(empty($this->post['cid'])) $this->create_class();

    	//创建提问用户和回答用户
    	$this->create_user();

		//设置用户信息
		$this->set_user();

    	//发布问题
    	$this->publish_question();

    	//发布回答
    	$this->publish_answer();

		//发布成功
    	$this->jk_success();
    }

	//获取分类下拉菜单
	private function get_class_tree() {
		echo '<select name="list">';
		foreach($this->get_category_list() as $value) {
			echo '<option value="'. $value['id'] .'">'. $value['name'] .'</option>';
		}
		echo '</select>';
		exit;
	}

    //创建分类
    private function create_class() {
    	if(trim($this->post['class']) === '') $this->jk_error('分类不能为空!');

		$cname_list = explode($this->jkconfig['sep'], $this->post['class']);

    	foreach($cname_list as $key => $cname) {
    		$category = $this->get_category_list();

			if(array_key_exists($cname, $category)) continue; //跳过已存在的分类

			if($key == 0) { //根分类
				$pid = 0;
			} else if(isset($category[$cname_list[$key - 1]])) {
				$pid = $category[$cname_list[$key - 1]]['id'];
			} else {
				$this->jk_error('上级分类创建失败!'); //应该不会发生
			}

			$_ENV['category']->add(array($cname .'，'. Pinyin($cname, $this->jkconfig['charset'])), $pid);

			cleardir(TIPASK_ROOT.'/data/cache'); //清除缓存文件
    	}
    }

	//创建提问用户和回答用户
	private function create_user() {
		$user_list = $this->get_curr_user_list();

		foreach($user_list as $key => $user) {
			$username = trim($user);

			if(empty($username) || $_ENV['user']->get_by_username($username)) continue;

			$password = substr(md5($username . $this->jkconfig['pwd_code']), 0, 10); //由程序生成用户密码

			$uid = $_ENV['user']->add($username, $password);

			if(!$uid) $this->jk_error('创建用户失败: '. $username);

			$credit1_register = mt_rand(500, 10000); //随机生成用户积分1
			$credit2_register = mt_rand(500, 10000); //随机生成用户积分2

			//注册用户分配积分
			$this->user = $_ENV['user']->get_by_username($username);
			$this->user['grouptype'] = 2; //普通用户才会根据积分调整所在组
	        $this->credit($uid, $credit1_register, $credit2_register);
		}
	}

	//设置用户组
	private function set_user() {
		$user_list = array();
		foreach($this->get_curr_user_list() as $username) {
			$user = $_ENV['user']->get_by_username($username);
			$user_list[$username] = $user;
		}
		$this->user_list = $user_list;
		$this->user = $user_list[$this->post['user']]; //用户信息改为提问用户
	}

	//获取当前用户名列表(提问用户名+回答用户名) 注意这里已去重
	private function get_curr_user_list() {
		$return_array = array_merge(array($this->post['user']), explode($this->jkconfig['sep'], $this->post['answer_user']));
		return array_unique($return_array);
	}

	//发布问题
	private function publish_question() {
		$title = $this->post['title'];
        $description = $this->post['description'];

		if(isset($this->post['cid'])) {
			$category = $this->get_category_list('id');

			if(array_key_exists($this->post['cid'], $category)) {
				$cid = $this->post['cid'];
				list($cid1, $cid2, $cid3) = explode(',', $category[$this->post['cid']]['cids']);
			} else {
				$this->jk_error('不存在的分类ID');
			}
		} else {
			$category = $this->get_category_list();
			$category_curr = explode($this->jkconfig['sep'], $this->post['class']);
	
			$cid1 = isset($category_curr[0]) && isset($category[trim($category_curr[0])]) ? $category[trim($category_curr[0])]['id'] : '';
			$cid2 = isset($category_curr[1]) && isset($category[trim($category_curr[1])]) ? $category[trim($category_curr[1])]['id'] : '';
			$cid3 = isset($category_curr[2]) && isset($category[trim($category_curr[2])]) ? $category[trim($category_curr[2])]['id'] : '';
	
			//最后一个不为空的ID 即最后一级分类
			if($cid1 != '') $cid = $cid1;
			if($cid2 != '') $cid = $cid2;
			if($cid3 != '') $cid = $cid3;
		}

        $tags = array_filter(explode($this->jkconfig['sep'], $this->post['tags'])); //标签

        $price = intval($this->post['givescore']); //悬赏分

		if($this->jkconfig['check_repeat'] && $_ENV['question']->get_by_title($title)) $this->jk_error('已存在的标题: '. $title); //跳过重复

		$_ENV['jiekou']->change_user_info($this->user_list[$this->post['user']]);

        $qid = $_ENV['question']->add($title, $description, 0, $price, $cid, $cid1, $cid2, $cid3, 1);
        $tags && $_ENV['tag']->multi_add($tags, $qid);

        //增加用户积分，扣除用户悬赏的财富
        if ($this->user['uid']) $this->credit($this->user['uid'], 0, -$price, 0, 'offer');
	}

	//回答问题
	private function publish_answer() {
		$answer_user_list = explode($this->jkconfig['sep'], $this->post['answer_user']);
		$answer_content_list = explode($this->jkconfig['sep'], $this->post['answer_content']);
		$answer_time_list = explode($this->jkconfig['sep'], $this->post['answer_time']);

		if(count($answer_user_list) == 0) return; //没有人回答问题

		$question = $_ENV['question']->get_by_title($this->post['title']);
		$qid = $question['id'];
		foreach($answer_user_list as $key => $answer_user) {
	        if($_ENV['question']->already($qid, $this->user_list[$answer_user_list[$key]]['uid'])) continue; //$this->message('不能重复回答同一个问题，可以修改自己的回答！', 'question/view/' . $qid);

	        $title = $this->post['title'];
	        $content = $answer_content_list[$key];

			$_ENV['jiekou']->change_user_info($this->user_list[$answer_user_list[$key]]);
			$_ENV['jiekou']->change_base_time($answer_time_list[$key]);

	        $_ENV['answer']->add($qid, $title, $content, 1);
		}
	}

    //获取分类列表, 键自定义
    private function get_category_list($key = 'name') {
    	$this->categorylist = $_ENV['category']->get_list();
    	$relation = array();
		foreach($this->categorylist as $value) {
			$relation[$value['id']] = $value['pid'];
		}
		$this->relation = $relation;

    	$return_array = array();
    	foreach($this->categorylist as $value) {
    		$value['cids'] = $this->relation($value, $relation);
    		$return_array[$value[$key]] = $value;
    	}

    	return $return_array;
    }

	private function relation($row) {
		$relation = $this->relation;
		if($row['grade'] == 3) {
			$cid3 = $row['id'];
			$cid2 = $row['pid'];
			$cid1 = $relation[$cid2]['pid'];
		} else if($row['grade'] == 2) {
			$cid3 = 0;
			$cid2 = $row['id'];
			$cid1 = $row['pid'];
		} else if($row['grade'] == 1) {
			$cid3 = 0;
			$cid2 = 0;
			$cid1 = $row['id'];
		}
		return $cid1 .','. $cid2 .','. $cid3;
	}

    //返回错误提示
    private function jk_error($str) {
    	exit('发布失败! 原因: '. $str);
    }

    //返回成功提示
    private function jk_success($str = '') {
    	exit('发布成功!');
    }
}

//汉字转拼音 - 官方的不给力
function Pinyin($_String, $_Code = 'gb2312') {
$_DataKey = "a|ai|an|ang|ao|ba|bai|ban|bang|bao|bei|ben|beng|bi|bian|biao|bie|bin|bing|bo|bu|ca|cai|can|cang|cao|ce|ceng|cha".
"|chai|chan|chang|chao|che|chen|cheng|chi|chong|chou|chu|chuai|chuan|chuang|chui|chun|chuo|ci|cong|cou|cu|".
"cuan|cui|cun|cuo|da|dai|dan|dang|dao|de|deng|di|dian|diao|die|ding|diu|dong|dou|du|duan|dui|dun|duo|e|en|er".
"|fa|fan|fang|fei|fen|feng|fo|fou|fu|ga|gai|gan|gang|gao|ge|gei|gen|geng|gong|gou|gu|gua|guai|guan|guang|gui".
"|gun|guo|ha|hai|han|hang|hao|he|hei|hen|heng|hong|hou|hu|hua|huai|huan|huang|hui|hun|huo|ji|jia|jian|jiang".
"|jiao|jie|jin|jing|jiong|jiu|ju|juan|jue|jun|ka|kai|kan|kang|kao|ke|ken|keng|kong|kou|ku|kua|kuai|kuan|kuang".
"|kui|kun|kuo|la|lai|lan|lang|lao|le|lei|leng|li|lia|lian|liang|liao|lie|lin|ling|liu|long|lou|lu|lv|luan|lue".
"|lun|luo|ma|mai|man|mang|mao|me|mei|men|meng|mi|mian|miao|mie|min|ming|miu|mo|mou|mu|na|nai|nan|nang|nao|ne".
"|nei|nen|neng|ni|nian|niang|niao|nie|nin|ning|niu|nong|nu|nv|nuan|nue|nuo|o|ou|pa|pai|pan|pang|pao|pei|pen".
"|peng|pi|pian|piao|pie|pin|ping|po|pu|qi|qia|qian|qiang|qiao|qie|qin|qing|qiong|qiu|qu|quan|que|qun|ran|rang".
"|rao|re|ren|reng|ri|rong|rou|ru|ruan|rui|run|ruo|sa|sai|san|sang|sao|se|sen|seng|sha|shai|shan|shang|shao|".
"she|shen|sheng|shi|shou|shu|shua|shuai|shuan|shuang|shui|shun|shuo|si|song|sou|su|suan|sui|sun|suo|ta|tai|".
"tan|tang|tao|te|teng|ti|tian|tiao|tie|ting|tong|tou|tu|tuan|tui|tun|tuo|wa|wai|wan|wang|wei|wen|weng|wo|wu".
"|xi|xia|xian|xiang|xiao|xie|xin|xing|xiong|xiu|xu|xuan|xue|xun|ya|yan|yang|yao|ye|yi|yin|ying|yo|yong|you".
"|yu|yuan|yue|yun|za|zai|zan|zang|zao|ze|zei|zen|zeng|zha|zhai|zhan|zhang|zhao|zhe|zhen|zheng|zhi|zhong|".
"zhou|zhu|zhua|zhuai|zhuan|zhuang|zhui|zhun|zhuo|zi|zong|zou|zu|zuan|zui|zun|zuo";
$_DataValue = "-20319|-20317|-20304|-20295|-20292|-20283|-20265|-20257|-20242|-20230|-20051|-20036|-20032|-20026|-20002|-19990".
"|-19986|-19982|-19976|-19805|-19784|-19775|-19774|-19763|-19756|-19751|-19746|-19741|-19739|-19728|-19725".
"|-19715|-19540|-19531|-19525|-19515|-19500|-19484|-19479|-19467|-19289|-19288|-19281|-19275|-19270|-19263".
"|-19261|-19249|-19243|-19242|-19238|-19235|-19227|-19224|-19218|-19212|-19038|-19023|-19018|-19006|-19003".
"|-18996|-18977|-18961|-18952|-18783|-18774|-18773|-18763|-18756|-18741|-18735|-18731|-18722|-18710|-18697".
"|-18696|-18526|-18518|-18501|-18490|-18478|-18463|-18448|-18447|-18446|-18239|-18237|-18231|-18220|-18211".
"|-18201|-18184|-18183|-18181|-18012|-17997|-17988|-17970|-17964|-17961|-17950|-17947|-17931|-17928|-17922".
"|-17759|-17752|-17733|-17730|-17721|-17703|-17701|-17697|-17692|-17683|-17676|-17496|-17487|-17482|-17468".
"|-17454|-17433|-17427|-17417|-17202|-17185|-16983|-16970|-16942|-16915|-16733|-16708|-16706|-16689|-16664".
"|-16657|-16647|-16474|-16470|-16465|-16459|-16452|-16448|-16433|-16429|-16427|-16423|-16419|-16412|-16407".
"|-16403|-16401|-16393|-16220|-16216|-16212|-16205|-16202|-16187|-16180|-16171|-16169|-16158|-16155|-15959".
"|-15958|-15944|-15933|-15920|-15915|-15903|-15889|-15878|-15707|-15701|-15681|-15667|-15661|-15659|-15652".
"|-15640|-15631|-15625|-15454|-15448|-15436|-15435|-15419|-15416|-15408|-15394|-15385|-15377|-15375|-15369".
"|-15363|-15362|-15183|-15180|-15165|-15158|-15153|-15150|-15149|-15144|-15143|-15141|-15140|-15139|-15128".
"|-15121|-15119|-15117|-15110|-15109|-14941|-14937|-14933|-14930|-14929|-14928|-14926|-14922|-14921|-14914".
"|-14908|-14902|-14894|-14889|-14882|-14873|-14871|-14857|-14678|-14674|-14670|-14668|-14663|-14654|-14645".
"|-14630|-14594|-14429|-14407|-14399|-14384|-14379|-14368|-14355|-14353|-14345|-14170|-14159|-14151|-14149".
"|-14145|-14140|-14137|-14135|-14125|-14123|-14122|-14112|-14109|-14099|-14097|-14094|-14092|-14090|-14087".
"|-14083|-13917|-13914|-13910|-13907|-13906|-13905|-13896|-13894|-13878|-13870|-13859|-13847|-13831|-13658".
"|-13611|-13601|-13406|-13404|-13400|-13398|-13395|-13391|-13387|-13383|-13367|-13359|-13356|-13343|-13340".
"|-13329|-13326|-13318|-13147|-13138|-13120|-13107|-13096|-13095|-13091|-13076|-13068|-13063|-13060|-12888".
"|-12875|-12871|-12860|-12858|-12852|-12849|-12838|-12831|-12829|-12812|-12802|-12607|-12597|-12594|-12585".
"|-12556|-12359|-12346|-12320|-12300|-12120|-12099|-12089|-12074|-12067|-12058|-12039|-11867|-11861|-11847".
"|-11831|-11798|-11781|-11604|-11589|-11536|-11358|-11340|-11339|-11324|-11303|-11097|-11077|-11067|-11055".
"|-11052|-11045|-11041|-11038|-11024|-11020|-11019|-11018|-11014|-10838|-10832|-10815|-10800|-10790|-10780".
"|-10764|-10587|-10544|-10533|-10519|-10331|-10329|-10328|-10322|-10315|-10309|-10307|-10296|-10281|-10274".
"|-10270|-10262|-10260|-10256|-10254";
$_TDataKey = explode('|', $_DataKey);
$_TDataValue = explode('|', $_DataValue);
$_Data = (PHP_VERSION>='5.0') ? array_combine($_TDataKey, $_TDataValue) : _Array_Combine($_TDataKey, $_TDataValue);
arsort($_Data);
reset($_Data);
if($_Code != 'gb2312') $_String = _U2_Utf8_Gb($_String);
$_Res = '';
for($i=0; $i<strlen($_String); $i++)
{
$_P = ord(substr($_String, $i, 1));
if($_P>160) { $_Q = ord(substr($_String, ++$i, 1)); $_P = $_P*256 + $_Q - 65536; }
$_Res .= _Pinyin($_P, $_Data);
}
return preg_replace("/[^a-z0-9]*/", '', $_Res);
}
function _Pinyin($_Num, $_Data)
{
if ($_Num>0 && $_Num<160 ) return chr($_Num);
elseif($_Num<-20319 || $_Num>-10247) return '';
else {
foreach($_Data as $k=>$v){ if($v<=$_Num) break; }
return $k;
}
}
function _U2_Utf8_Gb($_C)
{
$_String = '';
if($_C < 0x80) $_String .= $_C;
elseif($_C < 0x800)
{
$_String .= chr(0xC0 | $_C>>6);
$_String .= chr(0x80 | $_C & 0x3F);
}elseif($_C < 0x10000){
$_String .= chr(0xE0 | $_C>>12);
$_String .= chr(0x80 | $_C>>6 & 0x3F);
$_String .= chr(0x80 | $_C & 0x3F);
} elseif($_C < 0x200000) {
$_String .= chr(0xF0 | $_C>>18);
$_String .= chr(0x80 | $_C>>12 & 0x3F);
$_String .= chr(0x80 | $_C>>6 & 0x3F);
$_String .= chr(0x80 | $_C & 0x3F);
}
return iconv('UTF-8', 'GB2312', $_String);
}
function _Array_Combine($_Arr1, $_Arr2)
{
for($i=0; $i<count($_Arr1); $i++) $_Res[$_Arr1[$i]] = $_Arr2[$i];
return $_Res;
}
?>